package randomcitygenerator;

import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import javax.imageio.ImageIO;

/**
 *
 * @author Martin
 */
public class CityBuilder extends BlockInfo {

    public BufferedImage cityImage;

    /**
     *  
     *  0   3   6   9    12   15
     *  1   4   7   10   13   16
     *  2   5   8   11   14   17
     * 
     */
    private BufferedImage[] blockImages;

    public void init(URL tileSet, int columns, int rows) {
        try {
            BufferedImage image = ImageIO.read(tileSet);
            BufferedImage blockImage;
            blockImages = new BufferedImage[columns * rows];
            int i = 0;
            for (int x = 0; x < columns; x++) {
                for (int y = 0; y < rows; y++) {
                    if (i >= columns * rows) {
                        break;
                    }
                    try {
                        blockImage = image.getSubimage(
                                x * BLOCK_SIZE,
                                y * BLOCK_SIZE,
                                BLOCK_SIZE,
                                BLOCK_SIZE
                        );
                        blockImages[i] = blockImage;
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                    i++;
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void build(int[][] map, Dimension size) {
        cityImage = new BufferedImage(size.width*BLOCK_SIZE, size.height*BLOCK_SIZE, BufferedImage.TYPE_INT_ARGB);
        
        Graphics2D g2 = cityImage.createGraphics();
        
        for(int x = 0;x < size.width;x++){
            for(int y = 0;y < size.height;y++){
                g2.drawImage(
                        blockImages[ map[x][y] ], 
                        x * BLOCK_SIZE, 
                        y * BLOCK_SIZE,
                        null    
                );
            }
        }
        
    }

}
