package randomcitygenerator;

import java.awt.Point;
import java.util.ArrayList;

/**
 *
 * @author Martin
 */
public class RoadTracing {

    public final int LEFT = 0;
    public final int UP = 1;
    public final int RIGHT = 2;
    public final int DOWN = 3;

    public Point startPosition;
    public ArrayList<Point> lastPositions;
    public Point position;
    public int length = 0;

     public RoadTracing(){}
    
    public RoadTracing(Point p) {
        this.position = new Point(p.x, p.y);
        this.startPosition = new Point(p.x, p.y);
        this.lastPositions = new ArrayList<>();
        this.lastPositions.add(this.startPosition);
    }
    
    public Point getStart(){
        return this.startPosition;
    }
    
    public void next(int direction) {
        if (direction < 0 || direction > 3) {
            return;
        }
        switch (direction) {
            case LEFT:
                this.position.x--;
                break;
            case UP:
                this.position.y--;
                break;
            case RIGHT:
                this.position.x++;
                break;
            case DOWN:
                this.position.y++;
                break;
        }
        this.length++;
    }
    
    public void addPosition(){
        lastPositions.add(new Point(this.position.x, this.position.y));
    }

}
