﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TownGenerator.TownGeneration
{
    public sealed class Tile
    {
        public Tile(TileType type)
        {
            TileType = type;
        }

        public TileType TileType { get; }
        public Tile RightTile { get; set; }
        public Tile LeftTile { get; set; }
        public Tile TopTile { get; set; }
        public Tile BottomTile { get; set; }

        public int GetTileIndex()
        {
            if (TileType == TileType.Building) return 6;

            if (TileType == TileType.Road)
            {
                if (RightTile.TileType == TileType.Road && BottomTile.TileType == TileType.Road &&
                    LeftTile.TileType != TileType.Road && TopTile.TileType != TileType.Road) return 1;
                if (RightTile.TileType != TileType.Road && BottomTile.TileType == TileType.Road &&
                    LeftTile.TileType == TileType.Road && TopTile.TileType != TileType.Road) return 2;
                if (RightTile.TileType != TileType.Road && BottomTile.TileType == TileType.Road &&
                    LeftTile.TileType != TileType.Road && TopTile.TileType == TileType.Road) return 3;
                if (RightTile.TileType != TileType.Road && BottomTile.TileType == TileType.Road &&
                    LeftTile.TileType == TileType.Road && TopTile.TileType == TileType.Road) return 4;
                if (RightTile.TileType == TileType.Road && BottomTile.TileType == TileType.Road &&
                    LeftTile.TileType == TileType.Road && TopTile.TileType != TileType.Road) return 5;
                if (RightTile.TileType == TileType.Road && BottomTile.TileType != TileType.Road &&
                     LeftTile.TileType != TileType.Road && TopTile.TileType == TileType.Road) return 7;
                if (RightTile.TileType != TileType.Road && BottomTile.TileType != TileType.Road &&
                    LeftTile.TileType == TileType.Road && TopTile.TileType == TileType.Road) return 8;
                if (RightTile.TileType == TileType.Road && BottomTile.TileType != TileType.Road &&
                    LeftTile.TileType == TileType.Road && TopTile.TileType != TileType.Road) return 9;
                if (RightTile.TileType == TileType.Road && BottomTile.TileType == TileType.Road &&
                    LeftTile.TileType != TileType.Road && TopTile.TileType == TileType.Road) return 10;
                if (RightTile.TileType == TileType.Road && BottomTile.TileType != TileType.Road &&
                    LeftTile.TileType == TileType.Road && TopTile.TileType == TileType.Road) return 11;
                if (RightTile.TileType == TileType.Road && BottomTile.TileType == TileType.Road &&
                    LeftTile.TileType == TileType.Road && TopTile.TileType == TileType.Road) return 12;
                if (RightTile.TileType == TileType.Road && BottomTile.TileType != TileType.Road &&
                    LeftTile.TileType != TileType.Road && TopTile.TileType != TileType.Road) return 13;
                if (RightTile.TileType != TileType.Road && BottomTile.TileType != TileType.Road &&
                    LeftTile.TileType == TileType.Road && TopTile.TileType != TileType.Road) return 14;
                if (RightTile.TileType != TileType.Road && BottomTile.TileType != TileType.Road &&
                    LeftTile.TileType != TileType.Road && TopTile.TileType == TileType.Road) return 15;
                if (RightTile.TileType != TileType.Road && BottomTile.TileType == TileType.Road &&
                    LeftTile.TileType != TileType.Road && TopTile.TileType != TileType.Road) return 16;
            }
            return 0;
        }
    }
}
